FastLevels = LibStub("AceAddon-3.0"):NewAddon("FastLevels", "AceConsole-3.0", "AceEvent-3.0");

local M = LibStub("LibSharedMedia-3.0")
local db

local function FastLevels_CreateFrames()
	db = FastLevels.db.profile

	FLFrame = CreateFrame("Frame", "FastLevelsFLFrame", UIParent)
	FLFrame:SetHeight(db.height)
	FLFrame:SetWidth(db.width)
	FLFrame:SetPoint("CENTER", UIParent, "CENTER", db.x, db.y)
	FLFrame.background = FLFrame:CreateTexture(nil, "BACKGROUND")
	FLFrame.background:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.background:SetVertexColor(0,0,0)
	FLFrame.background:SetAllPoints(FLFrame)
	
	FLFrame.dotbackground = FLFrame:CreateTexture(nil, "BACKGROUND")
	FLFrame.dotbackground:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dotbackground:SetVertexColor(0,0,0)
	FLFrame.dotbackground:SetHeight(db.dotheight)
	FLFrame.dotbackground:SetWidth(FLFrame:GetWidth())
	FLFrame.dotbackground:SetPoint("BOTTOMLEFT", FLFrame, "TOPLEFT")
	
	local dotheight = (FLFrame.dotbackground:GetHeight()-1)
	local dotwidth = (((FLFrame:GetWidth())-21)/20)
	
	FLFrame.dot1 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot1:SetHeight(dotheight)
	FLFrame.dot1:SetWidth(dotwidth)
	FLFrame.dot1:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot1:SetVertexColor(0,1,0)
	FLFrame.dot1:SetPoint("BOTTOMLEFT", FLFrame, "TOPLEFT", 1, 0)
	
	FLFrame.dot2 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot2:SetHeight(dotheight)
	FLFrame.dot2:SetWidth(dotwidth)
	FLFrame.dot2:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot2:SetVertexColor(0,1,0)
	FLFrame.dot2:SetPoint("BOTTOMLEFT", FLFrame.dot1, "BOTTOMRIGHT", 1, 0)
	
	
	FLFrame.dot3 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot3:SetHeight(dotheight)
	FLFrame.dot3:SetWidth(dotwidth)
	FLFrame.dot3:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot3:SetVertexColor(0,1,0)
	FLFrame.dot3:SetPoint("BOTTOMLEFT", FLFrame.dot2, "BOTTOMRIGHT", 1, 0)
	
	
	FLFrame.dot4 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot4:SetHeight(dotheight)
	FLFrame.dot4:SetWidth(dotwidth)
	FLFrame.dot4:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot4:SetVertexColor(0,1,0)
	FLFrame.dot4:SetPoint("BOTTOMLEFT", FLFrame.dot3, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot5 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot5:SetHeight(dotheight)
	FLFrame.dot5:SetWidth(dotwidth)
	FLFrame.dot5:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot5:SetVertexColor(0,1,0)
	FLFrame.dot5:SetPoint("BOTTOMLEFT", FLFrame.dot4, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot6 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot6:SetHeight(dotheight)
	FLFrame.dot6:SetWidth(dotwidth)
	FLFrame.dot6:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot6:SetVertexColor(0,1,0)
	FLFrame.dot6:SetPoint("BOTTOMLEFT", FLFrame.dot5, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot7 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot7:SetHeight(dotheight)
	FLFrame.dot7:SetWidth(dotwidth)
	FLFrame.dot7:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot7:SetVertexColor(0,1,0)
	FLFrame.dot7:SetPoint("BOTTOMLEFT", FLFrame.dot6, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot8 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot8:SetHeight(dotheight)
	FLFrame.dot8:SetWidth(dotwidth)
	FLFrame.dot8:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot8:SetVertexColor(0,1,0)
	FLFrame.dot8:SetPoint("BOTTOMLEFT", FLFrame.dot7, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot9 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot9:SetHeight(dotheight)
	FLFrame.dot9:SetWidth(dotwidth)
	FLFrame.dot9:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot9:SetVertexColor(0,1,0)
	FLFrame.dot9:SetPoint("BOTTOMLEFT", FLFrame.dot8, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot10 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot10:SetHeight(dotheight)
	FLFrame.dot10:SetWidth(dotwidth)
	FLFrame.dot10:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot10:SetVertexColor(0,1,0)
	FLFrame.dot10:SetPoint("BOTTOMLEFT", FLFrame.dot9, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot11 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot11:SetHeight(dotheight)
	FLFrame.dot11:SetWidth(dotwidth)
	FLFrame.dot11:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot11:SetVertexColor(0,1,0)
	FLFrame.dot11:SetPoint("BOTTOMLEFT", FLFrame.dot10, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot12 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot12:SetHeight(dotheight)
	FLFrame.dot12:SetWidth(dotwidth)
	FLFrame.dot12:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot12:SetVertexColor(0,1,0)
	FLFrame.dot12:SetPoint("BOTTOMLEFT", FLFrame.dot11, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot13 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot13:SetHeight(dotheight)
	FLFrame.dot13:SetWidth(dotwidth)
	FLFrame.dot13:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot13:SetVertexColor(0,1,0)
	FLFrame.dot13:SetPoint("BOTTOMLEFT", FLFrame.dot12, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot14 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot14:SetHeight(dotheight)
	FLFrame.dot14:SetWidth(dotwidth)
	FLFrame.dot14:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot14:SetVertexColor(0,1,0)
	FLFrame.dot14:SetPoint("BOTTOMLEFT", FLFrame.dot13, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot15 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot15:SetHeight(dotheight)
	FLFrame.dot15:SetWidth(dotwidth)
	FLFrame.dot15:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot15:SetVertexColor(0,1,0)
	FLFrame.dot15:SetPoint("BOTTOMLEFT", FLFrame.dot14, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot16 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot16:SetHeight(dotheight)
	FLFrame.dot16:SetWidth(dotwidth)
	FLFrame.dot16:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot16:SetVertexColor(0,1,0)
	FLFrame.dot16:SetPoint("BOTTOMLEFT", FLFrame.dot15, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot17 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot17:SetHeight(dotheight)
	FLFrame.dot17:SetWidth(dotwidth)
	FLFrame.dot17:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot17:SetVertexColor(0,1,0)
	FLFrame.dot17:SetPoint("BOTTOMLEFT", FLFrame.dot16, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot18 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot18:SetHeight(dotheight)
	FLFrame.dot18:SetWidth(dotwidth)
	FLFrame.dot18:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot18:SetVertexColor(0,1,0)
	FLFrame.dot18:SetPoint("BOTTOMLEFT", FLFrame.dot17, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot19 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot19:SetHeight(dotheight)
	FLFrame.dot19:SetWidth(dotwidth)
	FLFrame.dot19:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot19:SetVertexColor(0,1,0)
	FLFrame.dot19:SetPoint("BOTTOMLEFT", FLFrame.dot18, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.dot20 = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.dot20:SetHeight(dotheight)
	FLFrame.dot20:SetWidth(dotwidth)
	FLFrame.dot20:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.dot20:SetVertexColor(0,1,0)
	FLFrame.dot20:SetPoint("BOTTOMLEFT", FLFrame.dot19, "BOTTOMRIGHT", 1, 0)
	
	FLFrame.barbackground = FLFrame:CreateTexture(nil, "LOW")
	FLFrame.barbackground:SetHeight(FLFrame:GetHeight()-2)
	FLFrame.barbackground:SetWidth(FLFrame:GetWidth()-2)
	FLFrame.barbackground:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.barbackground:SetVertexColor(0.25,0.25,0.25)
	FLFrame.barbackground:SetPoint("BOTTOMLEFT", FLFrame, "BOTTOMLEFT", 1, 1)
	
	FLFrame.bar = FLFrame:CreateTexture(nil, "OVERLAY")
	FLFrame.bar:SetHeight(FLFrame:GetHeight()-2)
	FLFrame.bar:SetWidth(1)
	FLFrame.bar:SetTexture(M:Fetch('statusbar', db.texture))
	FLFrame.bar:SetVertexColor(0,1,0)
	FLFrame.bar:SetPoint("BOTTOMLEFT", FLFrame, "BOTTOMLEFT", 1, 1)
	
	--[[Text Settings]]--
	FLFrame.toptext = FLFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	FLFrame.toptext:SetFont((M:Fetch('font', db.topfont)), db.toptextsize, db.toptextflags)
	FLFrame.toptext:SetPoint(db.toptextanchor, FLFrame.dotbackground, db.toptextanchor, db.toptextx, db.toptexty)
	local c1 = db.toptextcolor
	FLFrame.toptext:SetTextColor(c1.r,c1.g,c1.b)
	
	FLFrame.bottomtext = FLFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	FLFrame.bottomtext:SetFont((M:Fetch('font', db.bottomfont)), db.bottomtextsize, db.bottomtextflags)
	FLFrame.bottomtext:SetPoint(db.bottomtextanchor, FLFrame, db.bottomtextanchor, db.bottomtextx,db.bottomtexty)
	local c2 = db.bottomtextcolor
	FLFrame.bottomtext:SetTextColor(c2.r,c2.g,c2.b)
	FLFrame:SetScript("OnEnter", function() 
		UIFrameFadeRemoveFrame(FLFrame);
		UIFrameFlashRemoveFrame(FLFrame);
		UIFrameFadeIn(FLFrame, 0.1);
	end)

	FLFrame:SetScript("OnLeave", function() 
		UIFrameFadeRemoveFrame(FLFrame);
		UIFrameFlashRemoveFrame(FLFrame);
		UIFrameFadeOut(FLFrame, 0.25);
	end)
	
end



function FastLevelsUpdate()
	if not FLFrame then FastLevels_CreateFrames() end
	local xp,max,perc,filled,totalbars,barammount,barperc,barBGcolor,barcolor,dotcolor,dotBGcolor,toptext,bottomtext
	db = FastLevels.db.profile
	totalbars = 20
	barBGcolor = db.barBGcolor
	dotBGcolor = db.dotBGcolor
	if db.mode == 2 and GetWatchedFactionInfo() then
		local name, standing, wmin, wmax, value = GetWatchedFactionInfo()
		xp = (value-wmin)
		max = (wmax - wmin)
		perc = (100*(xp/max))
		filled = floor(perc/5)
		barammount = (perc - (5*filled))
		barperc = 100*(barammount/5)
		toptext = tostring(filled.."/"..totalbars)
		bottomtext = tostring(name.." ( "..xp.." / "..max.." ) "..getglobal("FACTION_STANDING_LABEL"..standing).." "..string.format("%0.1f", perc).."%")
		
		local color = FACTION_BAR_COLORS[standing]
		barcolor = color
		dotcolor = color
	elseif db.mode == 1 then
		xp = UnitXP("player")
		max = UnitXPMax("player")
		perc = (100*(xp/max))
		filled = floor(perc/5)
		barammount = (perc - (5*filled))
		barperc = 100*(barammount/5)	
		toptext = tostring(filled.."/"..totalbars)
		bottomtext = tostring(string.format("%0.1f", barperc).."%")
		barcolor = db.barcolor
		dotcolor = db.dotcolor
	else
		xp = 1234
		max = 2000
		perc = (100*(xp/max))
		filled = floor(perc/5)
		barammount = (perc - (5*filled))
		barperc = 100*(barammount/5)	
		toptext = "No reputation watched while in reputation watch mode."
		bottomtext = "Set a watched reputation first!"
		barcolor = {r = 0.15,g = 0.15,b = 0.15}
		dotcolor = {r = 0.15,g = 0.15,b = 0.15}
	end
	
	FLFrame:SetHeight(db.height or 17)
	FLFrame:SetWidth(db.width or 961)
	FLFrame:SetScale(db.scale or 1)
	
	FLFrame:SetPoint("CENTER", UIParent, "CENTER", db.x, db.y)
	
	FLFrame.barbackground:SetWidth(FLFrame:GetWidth()-2)
	FLFrame.barbackground:SetHeight(FLFrame:GetHeight()-2)
	FLFrame.barbackground:SetVertexColor(barBGcolor.r,barBGcolor.g,barBGcolor.b)
	FLFrame.barbackground:SetTexture(M:Fetch('statusbar', db.bartexture))
	
	FLFrame.bar:SetWidth((barperc*2)-2)
	FLFrame.bar:SetHeight(FLFrame:GetHeight()-2)
	FLFrame.bar:SetVertexColor(barcolor.r,barcolor.g,barcolor.b)
	FLFrame.bar:SetTexture(M:Fetch('statusbar', db.bartexture))	
	
	FLFrame.dotbackground:SetWidth(FLFrame:GetWidth())
	FLFrame.dotbackground:SetHeight(db.dotheight)
	
	-- Text Setting Updates --
	FLFrame.toptext:SetFont((M:Fetch('font', db.topfont)), db.toptextsize, db.toptextflags)
	FLFrame.toptext:ClearAllPoints()
	FLFrame.toptext:SetPoint(db.toptextanchor, FLFrame.dotbackground, db.toptextanchor, db.toptextx, db.toptexty)
	local c1 = db.toptextcolor
	FLFrame.toptext:SetTextColor(c1.r,c1.g,c1.b)
	
	FLFrame.bottomtext:ClearAllPoints()
	FLFrame.bottomtext:SetFont((M:Fetch('font', db.bottomfont)), db.bottomtextsize, db.bottomtextflags)
	FLFrame.bottomtext:SetPoint(db.bottomtextanchor, FLFrame, db.bottomtextanchor, db.bottomtextx, db.bottomtexty)
	local c2 = db.bottomtextcolor
	FLFrame.bottomtext:SetTextColor(c2.r,c2.g,c2.b)
	
	if db.toptext then
		FLFrame.toptext:SetText(toptext)
	else
		FLFrame.toptext:SetText(nil)
	end
	if db.bottomtext then
		FLFrame.bottomtext:SetText(bottomtext)
	else
		FLFrame.bottomtext:SetText(nil)
	end
	
	local dotheight = (FLFrame.dotbackground:GetHeight()-1)
	local dotwidth = (((FLFrame:GetWidth())-21)/20)
	
	for i=1,20 do
		index = "dot"..i
		FLFrame[index]:SetHeight(dotheight)
		FLFrame[index]:SetWidth(dotwidth)
		FLFrame[index]:SetTexture(M:Fetch('statusbar', db.texture))
		if i <= filled then
			FLFrame[index]:SetVertexColor(dotcolor.r,dotcolor.g,dotcolor.b)			
		else
			FLFrame[index]:SetVertexColor(dotBGcolor.r,dotBGcolor.g,dotBGcolor.b)
		end
	end	
end

local function FastLevels_Event(self,event,...)
	local arg1, arg2 = ...
	if event == "ADDON_LOADED" and arg1 == "FastLevels" then
		if not FastLevelsDB then FastLevelsDB = {} end
		FastLevels:RegisterOptions()
		FastLevels_CreateFrames()
	else
		FastLevelsUpdate()
	end	
end

local f = CreateFrame("Frame")
f:SetScript("OnEvent", function(self,event,...)
	FastLevels_Event(self,event,...)
end)
f:RegisterEvent('ADDON_LOADED')
f:RegisterEvent('UPDATE_EXHAUSTION')
f:RegisterEvent('UPDATE_FACTION')
f:RegisterEvent('PLAYER_XP_UPDATE')
f:RegisterEvent('PLAYER_LEVEL_UP')
f:RegisterEvent('PLAYER_LOGIN')